Bidirectional Forwarding Detection (BFD) for Virtual eXtensible Local Area Network (VXLAN)
RFC 8971
Santosh Pallagatti, Ed.
VMware
santosh.pallagatti@gmail.com
Greg Mirsky, Ed.
ZTE Corp.
gregimirsky@gmail.com
Sudarsan Paragiri
Individual Contributor
sudarsan.225@gmail.com
Vengada Prasad Govindan
Cisco
venggovi@cisco.com
Mallik Mudigonda
Cisco
mmudigon@cisco.com
December 2020
Routing
BFD
BFD
BFD for VXLAN
This document describes the use of the Bidirectional Forwarding Detection (BFD) protocol in point-to-point Virtual eXtensible Local Area Network (VXLAN) tunnels used to form an overlay network.
Introduction
"Virtual eXtensible Local Area Network (VXLAN)" [RFC7348] provides an encapsulation scheme that allows the building of an overlay network by decoupling the address space of the attached virtual hosts from that of the network.
One use of VXLAN is in data centers interconnecting virtual machines (VMs) of a tenant. VXLAN addresses the requirements of the Layer 2 and Layer 3 data-center network infrastructure in the presence of VMs in a multi-tenant environment by providing a Layer 2 overlay scheme on a Layer 3 network [RFC7348]. Another use is as an encapsulation for Ethernet VPN [RFC8365].
This document is written assuming the use of VXLAN for virtualized hosts and refers to VMs and VXLAN Tunnel End Points (VTEPs) in hypervisors. However, the concepts are equally applicable to non-virtualized hosts attached to VTEPs in switches.
In the absence of a router in the overlay, a VM can communicate with another VM only if they are on the same VXLAN segment. VMs are unaware of VXLAN tunnels, because a VXLAN tunnel is terminated on a VTEP. VTEPs are responsible for encapsulating and decapsulating frames exchanged among VMs.
The ability to monitor path continuity -- i.e., perform proactive continuity check (CC) for point-to-point (p2p) VXLAN tunnels -- is important. The asynchronous mode of BFD, as defined in [RFC5880], is used to monitor a p2p VXLAN tunnel.
In the case where a Multicast Service Node (MSN) (as described in Section 3.3 of [RFC8293]) participates in VXLAN, the mechanisms described in this document apply and can, therefore, be used to test the continuity of the path between the source Network Virtualization Endpoint (NVE) and the MSN.
This document describes the use of the Bidirectional Forwarding Detection (BFD) protocol to enable monitoring continuity of the path between VXLAN VTEPs that are performing as VNEs, and/or between the source NVE and a replicator MSN using a Management VXLAN Network Identifier (VNI) (Section 4). All other uses of the specification to test toward other VXLAN endpoints are out of scope.
Conventions Used in This Document
Abbreviations
BFD:
Bidirectional Forwarding Detection
CC:
Continuity Check
FCS:
Frame Check Sequence
MSN:
Multicast Service Node
NVE:
Network Virtualization Endpoint
p2p:
Point-to-point
VFI:
Virtual Forwarding Instance
VM:
Virtual Machine
VNI:
VXLAN Network Identifier (or VXLAN Segment ID)
VTEP:
VXLAN Tunnel End Point
VXLAN:
Virtual eXtensible Local Area Network
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Deployment
Figure 1 illustrates a scenario with two servers: each hosting two VMs. The servers host VTEPs that terminate two VXLAN tunnels with VNI number 100 and 200, respectively. Separate BFD sessions can be established between the VTEPs (IP1 and IP2) for monitoring each of the VXLAN tunnels (VNI 100 and 200). Using a BFD session to monitor a set of VXLAN VNIs between the same pair of VTEPs might help to detect and localize problems caused by misconfiguration. An implementation that supports this specification MUST be able to control the number of BFD sessions that can be created between the same pair of VTEPs. This method is applicable whether the VTEP is a virtual or physical device.
Reference VXLAN Domain

   +------------+-------------+
   |        Server 1          |
   | +----+----+  +----+----+ |
   | |VM1-1    |  |VM1-2    | |
   | |VNI 100  |  |VNI 200  | |
   | |         |  |         | |
   | +---------+  +---------+ |
   |        VTEP (IP1)        |
   +--------------------------+
                         |
                         |   +-------------+
                         |   |   Layer 3   |
                         +---|   Network   |
                             +-------------+
                                 |
                                 +-----------+
                                             |
                                      +------------+-------------+
                                      |         VTEP (IP2)       |
                                      | +----+----+  +----+----+ |
                                      | |VM2-1    |  |VM2-2    | |
                                      | |VNI 100  |  |VNI 200  | |
                                      | |         |  |         | |
                                      | +---------+  +---------+ |
                                      |      Server 2            |
                                      +--------------------------+

At the same time, a service-layer BFD session may be used between the tenants of VTEPs IP1 and IP2 to provide end-to-end fault management; this use case is outside the scope of this document. In such a case, for VTEPs, the BFD Control packets of that session are indistinguishable from data packets.
For BFD Control packets encapsulated in VXLAN (Figure 2), the inner destination IP address SHOULD be set to one of the loopback addresses from 127/8 range for IPv4 or to one of IPv4-mapped IPv6 loopback addresses from ::ffff:127.0.0.0/104 range for IPv6.
Use of the Management VNI
In most cases, a single BFD session is sufficient for the given VTEP to monitor the reachability of a remote VTEP, regardless of the number of VNIs. BFD control messages MUST be sent using the Management VNI, which acts as the control and management channel between VTEPs. An implementation MAY support operating BFD on another (non-Management) VNI, although the implications of this are outside the scope of this document. The selection of the VNI number of the Management VNI MUST be controlled through a management plane. An implementation MAY use VNI number 1 as the default value for the Management VNI. All VXLAN packets received on the Management VNI MUST be processed locally and MUST NOT be forwarded to a tenant.
BFD Packet Transmission over VXLAN Tunnel
BFD packets MUST be encapsulated and sent to a remote VTEP as explained in this section. Implementations SHOULD ensure that the BFD packets follow the same forwarding path as VXLAN data packets within the sender system.
BFD packets are encapsulated in VXLAN as described below. The VXLAN packet format is defined in Section 5 of [RFC7348]. The value in the VNI field of the VXLAN header MUST be set to the value selected as the Management VNI. The outer IP/UDP and VXLAN headers MUST be encoded by the sender, as defined in [RFC7348].
VXLAN Encapsulation of BFD Control Packet

  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                      Outer Ethernet Header                    ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                        Outer IPvX Header                      ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                        Outer UDP Header                       ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                           VXLAN Header                        ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                    Inner Ethernet Header                      ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                        Inner IPvX Header                      ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                         Inner UDP Header                      ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~                       BFD Control Packet                     ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                   Outer Ethernet FCS                          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The BFD packet MUST be carried inside the inner Ethernet frame of the VXLAN packet. The choice of destination Media Access Control (MAC) and destination IP addresses for the inner Ethernet frame MUST ensure that the BFD Control packet is not forwarded to a tenant but is processed locally at the remote VTEP. The inner Ethernet frame carrying the BFD Control packet has the following format:
Ethernet Header:
Destination MAC:
A Management VNI, which does not have any tenants, will have no dedicated MAC address for decapsulated traffic. The value 00-52-02 SHOULD be used in this field.
Source MAC:
MAC address associated with the originating VTEP.
Ethertype:
This is set to 0x0800 if the inner IP header is IPv4 and set to 0x86DD if the inner IP header is IPv6.
IP header:
Destination IP:
This IP address MUST NOT be of one of tenant's IP addresses. The IP address SHOULD be selected from the range 127/8 for IPv4 and from the range ::ffff:127.0.0.0/104 for IPv6. Alternatively, the destination IP address MAY be set to VTEP's IP address.
Source IP:
IP address of the originating VTEP.
TTL or Hop Limit:
MUST be set to 255, in accordance with [RFC5881].
The destination UDP port is set to 3784 and the fields of the BFD Control packet are encoded as specified in [RFC5881].
Reception of BFD Packet from VXLAN Tunnel
Once a packet is received, the VTEP MUST validate the packet. If the packet is received on the Management VNI and is identified as a BFD Control packet addressed to the VTEP, then the packet can be processed further. Processing of BFD Control packets received on a non-Management VNI is outside the scope of this specification.
The received packet's inner IP payload is then validated according to Sections 4 and 5 in [RFC5881].
Echo BFD
Support for echo BFD is outside the scope of this document.
IANA Considerations
IANA has assigned a single MAC address of the value 00-52-02 from the "Unassigned (small allocations)" block of the "IANA Unicast 48-bit MAC Addresses" registry as follows: the "Usage" field is "BFD for VXLAN". The "Reference" is this document.
Security Considerations
Security issues discussed in [RFC5880], [RFC5881], and [RFC7348] apply to this document.
This document recommends using an address from the internal host loopback addresses 127/8 range for IPv4, or an IP4-mapped IPv6 loopback address from the ::ffff:127.0.0.0/104 range for IPv6, as the destination IP address in the inner IP header. Using such an address prevents the forwarding of the encapsulated BFD control message by a transient node, in case the VXLAN tunnel is broken, in accordance with [RFC1812].
A router SHOULD NOT forward, except over a loopback interface, any packet that has a destination address on network 127. A router MAY have a switch that allows the network manager to disable these checks. If such a switch is provided, it MUST default to performing the checks.
The use of IPv4-mapped IPv6 addresses has the same property as using the IPv4 network 127/8. Moreover, the IPv4-mapped IPv6 addresses' prefix is not advertised in any routing protocol.
If the implementation supports establishing multiple BFD sessions between the same pair of VTEPs, there SHOULD be a mechanism to control the maximum number of such sessions that can be active at the same time.
References
Normative References
Informative References
[RFC7348]
[RFC8365]
[RFC5880]
[RFC8293]
[RFC2119]
[RFC8174]
[RFC5881]
[RFC1812]
Acknowledgments
The authors would like to thank Jeff Haas of Juniper Networks for his reviews and feedback on this material.
The authors would also like to thank Nobo Akiya, Marc Binderberger, Shahram Davari, Donald E. Eastlake 3rd, Anoop Ghanwani, Dinesh Dutt, Joel Halpern, and Carlos Pignataro for the extensive reviews and the most detailed and constructive comments.
Contributors
Reshad Rahman
Cisco
rrahman@cisco.com